#include <DHT.h>
#include <ESP8266WiFi.h>
#define PubNub_BASE_CLIENT WiFiClient
#include <PubNub.h>
#define PUBNUB_DEFINE_STRSPN_AND_STRNCASECMP
#include <ArduinoJson.h>
#include <LiquidCrystal_I2C.h>
#include<SoftwareSerial.h> //Included SoftwareSerial Library

//Started SoftwareSerial at RX and TX pin of ESP8266/NodeMCU

LiquidCrystal_I2C lcd(0x27, 16, 2);

SoftwareSerial s(3,1);
int buzzer = 0;
int SirenCounter = 0;

#define DHTTYPE DHT22
#define DHTPin D5 // Defines pin number to which the sensor is connected

DHT dht(DHTPin,DHTTYPE);

const char *ssid =  "";     // replace with your wifi ssid and wpa2 key
const char *pass =  "";

const char * pubkey = ""; // insert your iot credentials
const char * subkey = "";

const char * pubchannel = "green_house";
const char * subchannel = "green_house";


int LowTemp = 20;
int HighTemp = 26;
int LowHI = 40;
int HighHI = 70;

void setup() {
  int error;
    /* For debugging, set to speed of your choice */
    Serial.begin(115200);
    Serial.print("serial on");
    s.begin(9600);
    lcd.begin(16,2);
    lcd.init();
    lcd.backlight();
    

       Serial.println("Connecting to ");
       Serial.println(ssid); 

       lcd.setCursor(0,0);
       lcd.print("Connecting to");
       lcd.setCursor(6,1);
       lcd.print("WiFi");
       
       WiFi.begin(ssid, pass);
       for (int i = 0; i < 30; i++) {
       if (WiFi.status() != WL_CONNECTED) 
          {
            delay(500);
            Serial.print(".");
          }
       }
       
lcd.clear();
      

       if (WiFi.status() == WL_CONNECTED) {
        lcd.print("WIFI Connected");
        Serial.print("WiFi Connected");
        delay(2000);
    PubNub.begin(pubkey, subkey);
    lcd.clear();
    lcd.print("IOT Connected");
    delay(2000);
       }
       
       lcd.clear();
    dht.begin();
    Serial.print("loop starts");
    lcd.print("Main loop starts");
    delay(2000);
}

void loop() {
  

  float t = dht.readTemperature(); // Gets the values of the temperature
  float h = dht.readHumidity();
  float hi = dht.computeHeatIndex(t, h, false);
  

  delay(1000);

  String hi2;

  hi2 = String(hi, 1);

  Serial.println(t);
  Serial.println(h);
  Serial.println(hi2);
Serial.print("dht22 readings taken");

    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("T: "); lcd.print(String(t) + " C ");
    lcd.setCursor(0, 1);
    lcd.print("Hi: "); lcd.print(String(hi2) + "%");

  buzzer = 0;
  s.write(buzzer);

    if (t > HighTemp) {
      
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print("Alarm");
      lcd.setCursor(0, 1);
      lcd.print("Temp TOO HIGH " + String(t));
      delay(500);
      SirenOn();
      }

      if (t < LowTemp) {
      
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print("Alarm");
      lcd.setCursor(0, 1);
      lcd.print("Temp TOO LOW " + String(t));
      delay(500);
      SirenOn();
      }

      if (hi > HighHI) {
      
      lcd.clear();
      lcd.setCursor(4, 0);
      lcd.print("Alarm");
      lcd.setCursor(2, 1);
      lcd.print("HI TOO HIGH " + String(hi));
      delay(500);
      SirenOn();
      }

      if (hi < LowHI) {
      
      lcd.clear();
      lcd.setCursor(4, 0);
      lcd.print("Alarm");
      lcd.setCursor(2, 1);
      lcd.print("HI TOO LOw " + String(hi));
      delay(500);
      SirenOn();
      }
      
  char buf[500] = {};

if (WiFi.status() == WL_CONNECTED) {

const int capacity = JSON_OBJECT_SIZE(100);
StaticJsonDocument<capacity> doc;

doc["Temperature"] = t;
doc["Humidity"] = h;
doc["Heat Index"] = hi2;
doc["Siren"] = SirenCounter;

    serializeJson(doc, buf);
    
    PubNonSubClient *pclient = PubNub.publish(pubchannel, buf);
    if (!pclient) return;
    PublishCracker cheez;
    cheez.read_and_parse(pclient);

    Serial.print("Outcome: "); Serial.print(cheez.outcome());
    Serial.print(' '); Serial.println(cheez.to_str(cheez.outcome()));
    Serial.print("description: "); Serial.println(cheez.description());
    Serial.print("timestamp: "); Serial.println(cheez.timestamp());
    Serial.print("state: "); Serial.print(cheez.state());
    Serial.print(' '); Serial.println(cheez.to_str(cheez.state()));
    pclient->stop();

    
    PubSubClient *sclient = PubNub.subscribe(subchannel);
    if (!sclient) return; // error
    String msg;
    SubscribeCracker ritz(sclient);
    while (!ritz.finished()) {
        ritz.get(msg);
        if (msg.length() > 0) {
            Serial.print("Received: "); Serial.println(msg);
        }
    }
    sclient->stop();
    delay(1000);
}
}

void SirenOn() {
  buzzer = 1;
  s.write(buzzer);
  Serial.print("buzzer ON");
  delay(3000);
  SirenCounter += 1;
}

Upload the below code on arduino:-

#include<SoftwareSerial.h> //Included SoftwareSerial Library
//Started SoftwareSerial at RX and TX pin of Arduino
SoftwareSerial s(0,1);

int data; //Initialized variable to store received data

void setup() {
  //Serial Begin at 9600 Baud 
  //Serial.begin(9600);
  s.begin(9600);
  pinMode(9, INPUT);
  delay(10000);
}

void loop() {

//if (s.available()>0) {
  data = s.read(); //Read the serial data and store it
  //s.println(data);

    if (data == 0) {
    //s.println("Buzzer Deactivate");
    pinMode(9, INPUT);
    delay(1000);
    }
  
  if (data ==1) {
    //s.println("Buzzer Activate");
    pinMode(9, OUTPUT);
    delay(1000);
  }
}
